<?php

namespace Drupal\tmgmt_deepl_glossary;

use Drupal\Core\Access\AccessResult;
use Drupal\Core\Entity\EntityAccessControlHandler;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Session\AccountInterface;

/**
 * Access controller for the deepl_glossary_entry entity.
 *
 * @see \Drupal\tmgmt_deepl_glossary\Entity\DeeplGlossary
 */
class AccessControlHandler extends EntityAccessControlHandler {

  /**
   * {@inheritdoc}
   */
  protected function checkAccess(EntityInterface $entity, $operation, AccountInterface $account) {
    switch ($operation) {
      case 'view':
        return AccessResult::allowedIfHasPermission($account, 'view deepl_glossary entities');

      case 'update':
        return AccessResult::allowedIfHasPermission($account, 'edit deepl_glossary entities');

      case 'delete':
        return AccessResult::allowedIfHasPermission($account, 'delete deepl_glossary entities');

      default:
        // No opinion.
        return AccessResult::neutral();
    }
  }

  /**
   * {@inheritdoc}
   */
  protected function checkCreateAccess(AccountInterface $account, array $context, $entity_bundle = NULL) {
    return AccessResult::allowedIfHasPermission($account, 'add deepl_glossary entities');
  }

}
